/*
  Getestet unter
  IBM AIX 3.2.5 RS/6000,
  SunOS 4.1.1.,
  CADMUS MUNIX V.3/M-3
  UTS/AMDAHL
  APOLLO DOMAIN
  DEC AXP

  Compileraufruf: cc -o <binary> <source.c>

  Die Programmnamen sind
  -siso  (stdin/out eines beliebigen Programmes an einen Port anhaengen)

  -hopsel (hop, Routing, mit Systemaufruf select)
  -hopnb (wie oben, aber mit Systemaufruf ioctl f. nonblocking io)

  Die Syntax ist
  --------------
  siso <pfad/programm> <port eigener rechner>

  hopsel <Port eigener Rechner> <IP-Adresse fremder Rechner> <Port anderer Rechner>

  hopnb identisch.

  Programme in den Hintergrund &.

*/

/* siso.c */


#include <sys/types.h>
#include <sys/socket.h>		/* socket-Headerfile */
#include <netinet/in.h>		/* internet-definitionen */
#include <netdb.h>			/* Netz-"Datenbank"-Konventionen */
#include <stdio.h>

void application();

main(argc, argv)
int argc;
char *argv[];
{
 int sock, length, rval, msgsock, *stat;
 struct sockaddr_in server;
 char buf[1024];

/*
 *  Erzeugen eines Sockets
 */

 sock = socket(AF_INET, SOCK_STREAM, 0);
 
 server.sin_family = AF_INET;
 server.sin_addr.s_addr = INADDR_ANY;

/*
 * Festlegen des Partnerports
 */

 server.sin_port = atol(argv[2]);

 
 bind(sock, &server, sizeof(server));


/*
 * Auf Verbindung warten
 */

 listen(sock, 5);

 do{

/*
 * Eine Verbindung akzeptieren
 */

    msgsock = accept(sock, 0, 0);
    if(msgsock == -1) perror("accept");
       else
	switch(fork()){
		case  0: { application(msgsock, argv[1]); break;}
		case -1: { perror("fork"); break;}
		default: { close(msgsock); wait(stat);}
	}
 } while (1);
}


void application(com_sock, prog)
char *prog;
int com_sock;
{

/*
 * Umlenken der Standard-I/O-Kanaele auf die beiden Sockets und
 * endgueltiges Ausfuehren des Anwendungsprogrammes
 */

 close(0); dup2(com_sock, 0);
 close(1); dup2(com_sock, 1);
 close(2); dup2(com_sock, 2);

 execl(prog, NULL);
 exit();
}
